#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "hash.h"

typedef struct posn {
  int x;
  int y;
} posn;

posn* make_posn(int x, int y) {
  posn* p = (posn*)malloc(sizeof(posn));
  p->x = x;
  p->y = y;
  return p;
}

int compare_posn(void* _p1, void* _p2) {
  posn* p1 = (posn*)_p1;
  posn* p2 = (posn*)_p2;
  if ((p1->x == p2->x)
      && (p1->y == p2->y))
    return 0;
  else
    return 1;
}

int hash_posn(void* _p) {
  posn* p = (posn*)_p;

  return p->x + p->y;
}

int main(int argc, char** argv)
{
  hash_table* ht;
  void *val;
  char buffer[256];
  int print_it;
  FILE *f;

  ht = make_hash_table(compare_posn, hash_posn);

  hash_set(ht, make_posn(1, 2), "first");
  printf("%s\n", (char*)hash_get(ht, make_posn(1, 2)));
  printf("%s\n", (char*)hash_get(ht, make_posn(2, 1)));

  hash_set(ht, make_posn(2, 1), "second");
  printf("%s\n", (char*)hash_get(ht, make_posn(1, 2)));
  printf("%s\n", (char*)hash_get(ht, make_posn(2, 1)));

  return 0;
}
